--helper functions by fullerlee@hotmail.com

function waitForCross()
	Controls.waitpadup()
	while not pad:cross() do
		pad = Controls.read()
		screen.waitVblankStart()
	end
end

function getFont(x, y, width, height, fontImage)
	fontsize = fontsize or 1
	local font = Image.createEmpty(width+1,height+1)
	
	font:blit(0,0, fontImage, width*x, height*y, width+1, height+1, true)
	return font
end

function pause(seconds)
local t0 = os.clock()
	while (os.difftime(os.clock() - t0) < 1) do
		screen.waitVblankStart()
	end
end

function loadTileFont()
	y = 0
	for x = 0, 25 do
		tileFont[x] = getFont(x, y, TILE_WIDTH, TILE_HEIGHT, tileImage)
	end
	--get the blank tile
	tileFont[26] = getFont(0, 1, TILE_WIDTH, TILE_HEIGHT, tileImage)
	
	return tileFont
end

function drawChar(posX, posY, char, fontArray)
	charPos = getCharPos(char)
	screen:blit(posX, posY, fontArray[charPos])
end

function drawString(posX, posY, stringToDraw, fontArray)
	i = 1
	while string.byte(stringToDraw, i) do
		drawChar(posX + ((i-1)*fontArray[i]:width()), posY, string.char(string.byte(stringToDraw, i)), fontArray)
		i = i + 1
	end
end

function writeToDebug(stringToWrite)
	--io.write(stringToWrite.."\n")
end

function Controls.waitpadup() --pauses execution untill all buttons are released
   pad=Controls.read()
   while pad:select() or pad:start() or pad:up() or pad:right() or pad:down() or pad:left() or pad:l() or pad:r() or pad:triangle() or pad:circle() or pad:cross() or pad:square() do
      screen.waitVblankStart()
      pad=Controls.read()
   end
end

function stringPad(stringToPad, padWith, padTo, padLeft)
	paddedString = ""
	padString = ""
	for padCount=1, padTo - string.len(stringToPad) do
		padString = padString..padWith
	end
	
	if padLeft then
		paddedString = padString..stringToPad
	else
		paddedString = stringToPad..padString
	end

	return paddedString
end

function getCharPos(char)
	charPos = 0
	if string.byte(char) <= string.byte("Z") and
		string.byte(char) >= string.byte("A") then
		
		--A is at position 0
		charPos = (string.byte(char) - string.byte("A")) + 0
	elseif char=="[" then
		charPos = 26
	end

	return charPos
end

function saveOptions()
	file = io.open(optionsFile, "w")
	if file then
		for key, value in options do
			file:write(key .. "=" .. value .. "\n")
		end
		file:close()
	end
end

function loadOptions()
	file = io.open(optionsFile, "r")
	if file then
		for line in file:lines() do
			equal = string.find(line, "=")
			if equal then
				key = string.sub(line, 1, equal - 1)
				value = string.sub(line, equal + 1)
				if key == "numPlayers" or key == "numLetters" then 
					value = tonumber(value)			
				end
				options[key] = value
			end
		end
		file:close()
	end
end